<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>11.4. stat — Interpreting stat() results &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="11. File and Directory Access" href="filesys.html" />
    <link rel="next" title="11.5. filecmp — File and Directory Comparisons" href="filecmp.html" />
    <link rel="prev" title="11.3. fileinput — Iterate over lines from multiple input streams" href="fileinput.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="filecmp.html" title="11.5. filecmp — File and Directory Comparisons"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="fileinput.html" title="11.3. fileinput — Iterate over lines from multiple input streams"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="filesys.html" accesskey="U">11. File and Directory Access</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-stat">
<span id="stat-interpreting-stat-results"></span><h1>11.4. <a class="reference internal" href="#module-stat" title="stat: Utilities for interpreting the results of os.stat(), os.lstat() and os.fstat()."><code class="xref py py-mod docutils literal"><span class="pre">stat</span></code></a> &#8212; Interpreting <a class="reference internal" href="os.html#os.stat" title="os.stat"><code class="xref py py-func docutils literal"><span class="pre">stat()</span></code></a> results<a class="headerlink" href="#module-stat" title="Permalink to this headline">¶</a></h1>
<dl class="docutils">
<dt><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Modules/_stat.c">Modules/_stat.c</a></dt>
<dd><a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/stat.py">Lib/stat.py</a></dd>
</dl>
<hr class="docutils" />
<p>The <a class="reference internal" href="#module-stat" title="stat: Utilities for interpreting the results of os.stat(), os.lstat() and os.fstat()."><code class="xref py py-mod docutils literal"><span class="pre">stat</span></code></a> module defines constants and functions for interpreting the
results of <a class="reference internal" href="os.html#os.stat" title="os.stat"><code class="xref py py-func docutils literal"><span class="pre">os.stat()</span></code></a>, <a class="reference internal" href="os.html#os.fstat" title="os.fstat"><code class="xref py py-func docutils literal"><span class="pre">os.fstat()</span></code></a> and <a class="reference internal" href="os.html#os.lstat" title="os.lstat"><code class="xref py py-func docutils literal"><span class="pre">os.lstat()</span></code></a> (if they
exist).  For complete details about the <code class="xref c c-func docutils literal"><span class="pre">stat()</span></code>, <code class="xref c c-func docutils literal"><span class="pre">fstat()</span></code> and
<code class="xref c c-func docutils literal"><span class="pre">lstat()</span></code> calls, consult the documentation for your system.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The stat module is backed by a C implementation.</p>
</div>
<p>The <a class="reference internal" href="#module-stat" title="stat: Utilities for interpreting the results of os.stat(), os.lstat() and os.fstat()."><code class="xref py py-mod docutils literal"><span class="pre">stat</span></code></a> module defines the following functions to test for specific file
types:</p>
<dl class="function">
<dt id="stat.S_ISDIR">
<code class="descclassname">stat.</code><code class="descname">S_ISDIR</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISDIR" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a directory.</p>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISCHR">
<code class="descclassname">stat.</code><code class="descname">S_ISCHR</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISCHR" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a character special device file.</p>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISBLK">
<code class="descclassname">stat.</code><code class="descname">S_ISBLK</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISBLK" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a block special device file.</p>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISREG">
<code class="descclassname">stat.</code><code class="descname">S_ISREG</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISREG" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a regular file.</p>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISFIFO">
<code class="descclassname">stat.</code><code class="descname">S_ISFIFO</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISFIFO" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a FIFO (named pipe).</p>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISLNK">
<code class="descclassname">stat.</code><code class="descname">S_ISLNK</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISLNK" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a symbolic link.</p>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISSOCK">
<code class="descclassname">stat.</code><code class="descname">S_ISSOCK</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISSOCK" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a socket.</p>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISDOOR">
<code class="descclassname">stat.</code><code class="descname">S_ISDOOR</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISDOOR" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a door.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISPORT">
<code class="descclassname">stat.</code><code class="descname">S_ISPORT</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISPORT" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from an event port.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<dl class="function">
<dt id="stat.S_ISWHT">
<code class="descclassname">stat.</code><code class="descname">S_ISWHT</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_ISWHT" title="Permalink to this definition">¶</a></dt>
<dd><p>Return non-zero if the mode is from a whiteout.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<p>Two additional functions are defined for more general manipulation of the file&#8217;s
mode:</p>
<dl class="function">
<dt id="stat.S_IMODE">
<code class="descclassname">stat.</code><code class="descname">S_IMODE</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_IMODE" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the portion of the file&#8217;s mode that can be set by <a class="reference internal" href="os.html#os.chmod" title="os.chmod"><code class="xref py py-func docutils literal"><span class="pre">os.chmod()</span></code></a>&#8212;that is, the file&#8217;s permission bits, plus the sticky bit, set-group-id, and
set-user-id bits (on systems that support them).</p>
</dd></dl>

<dl class="function">
<dt id="stat.S_IFMT">
<code class="descclassname">stat.</code><code class="descname">S_IFMT</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.S_IFMT" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the portion of the file&#8217;s mode that describes the file type (used by the
<code class="xref py py-func docutils literal"><span class="pre">S_IS*()</span></code> functions above).</p>
</dd></dl>

<p>Normally, you would use the <code class="xref py py-func docutils literal"><span class="pre">os.path.is*()</span></code> functions for testing the type
of a file; the functions here are useful when you are doing multiple tests of
the same file and wish to avoid the overhead of the <code class="xref c c-func docutils literal"><span class="pre">stat()</span></code> system call
for each test.  These are also useful when checking for information about a file
that isn&#8217;t handled by <a class="reference internal" href="os.path.html#module-os.path" title="os.path: Operations on pathnames."><code class="xref py py-mod docutils literal"><span class="pre">os.path</span></code></a>, like the tests for block and character
devices.</p>
<p>Example:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">os</span><span class="o">,</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">stat</span> <span class="k">import</span> <span class="o">*</span>

<span class="k">def</span> <span class="nf">walktree</span><span class="p">(</span><span class="n">top</span><span class="p">,</span> <span class="n">callback</span><span class="p">):</span>
    <span class="sd">&#39;&#39;&#39;recursively descend the directory tree rooted at top,</span>
<span class="sd">       calling the callback function for each regular file&#39;&#39;&#39;</span>

    <span class="k">for</span> <span class="n">f</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">top</span><span class="p">):</span>
        <span class="n">pathname</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">top</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
        <span class="n">mode</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">stat</span><span class="p">(</span><span class="n">pathname</span><span class="p">)</span><span class="o">.</span><span class="n">st_mode</span>
        <span class="k">if</span> <span class="n">S_ISDIR</span><span class="p">(</span><span class="n">mode</span><span class="p">):</span>
            <span class="c"># It&#39;s a directory, recurse into it</span>
            <span class="n">walktree</span><span class="p">(</span><span class="n">pathname</span><span class="p">,</span> <span class="n">callback</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">S_ISREG</span><span class="p">(</span><span class="n">mode</span><span class="p">):</span>
            <span class="c"># It&#39;s a file, call the callback function</span>
            <span class="n">callback</span><span class="p">(</span><span class="n">pathname</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="c"># Unknown file type, print a message</span>
            <span class="nb">print</span><span class="p">(</span><span class="s">&#39;Skipping %s&#39;</span> <span class="o">%</span> <span class="n">pathname</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">visitfile</span><span class="p">(</span><span class="n">file</span><span class="p">):</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&#39;visiting&#39;</span><span class="p">,</span> <span class="n">file</span><span class="p">)</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">walktree</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">visitfile</span><span class="p">)</span>
</pre></div>
</div>
<p>An additional utility function is provided to convert a file&#8217;s mode in a human
readable string:</p>
<dl class="function">
<dt id="stat.filemode">
<code class="descclassname">stat.</code><code class="descname">filemode</code><span class="sig-paren">(</span><em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#stat.filemode" title="Permalink to this definition">¶</a></dt>
<dd><p>Convert a file&#8217;s mode to a string of the form &#8216;-rwxrwxrwx&#8217;.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.3.</span></p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The function supports <a class="reference internal" href="#stat.S_IFDOOR" title="stat.S_IFDOOR"><code class="xref py py-data docutils literal"><span class="pre">S_IFDOOR</span></code></a>, <a class="reference internal" href="#stat.S_IFPORT" title="stat.S_IFPORT"><code class="xref py py-data docutils literal"><span class="pre">S_IFPORT</span></code></a> and
<a class="reference internal" href="#stat.S_IFWHT" title="stat.S_IFWHT"><code class="xref py py-data docutils literal"><span class="pre">S_IFWHT</span></code></a>.</p>
</div>
</dd></dl>

<p>All the variables below are simply symbolic indexes into the 10-tuple returned
by <a class="reference internal" href="os.html#os.stat" title="os.stat"><code class="xref py py-func docutils literal"><span class="pre">os.stat()</span></code></a>, <a class="reference internal" href="os.html#os.fstat" title="os.fstat"><code class="xref py py-func docutils literal"><span class="pre">os.fstat()</span></code></a> or <a class="reference internal" href="os.html#os.lstat" title="os.lstat"><code class="xref py py-func docutils literal"><span class="pre">os.lstat()</span></code></a>.</p>
<dl class="data">
<dt id="stat.ST_MODE">
<code class="descclassname">stat.</code><code class="descname">ST_MODE</code><a class="headerlink" href="#stat.ST_MODE" title="Permalink to this definition">¶</a></dt>
<dd><p>Inode protection mode.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_INO">
<code class="descclassname">stat.</code><code class="descname">ST_INO</code><a class="headerlink" href="#stat.ST_INO" title="Permalink to this definition">¶</a></dt>
<dd><p>Inode number.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_DEV">
<code class="descclassname">stat.</code><code class="descname">ST_DEV</code><a class="headerlink" href="#stat.ST_DEV" title="Permalink to this definition">¶</a></dt>
<dd><p>Device inode resides on.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_NLINK">
<code class="descclassname">stat.</code><code class="descname">ST_NLINK</code><a class="headerlink" href="#stat.ST_NLINK" title="Permalink to this definition">¶</a></dt>
<dd><p>Number of links to the inode.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_UID">
<code class="descclassname">stat.</code><code class="descname">ST_UID</code><a class="headerlink" href="#stat.ST_UID" title="Permalink to this definition">¶</a></dt>
<dd><p>User id of the owner.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_GID">
<code class="descclassname">stat.</code><code class="descname">ST_GID</code><a class="headerlink" href="#stat.ST_GID" title="Permalink to this definition">¶</a></dt>
<dd><p>Group id of the owner.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_SIZE">
<code class="descclassname">stat.</code><code class="descname">ST_SIZE</code><a class="headerlink" href="#stat.ST_SIZE" title="Permalink to this definition">¶</a></dt>
<dd><p>Size in bytes of a plain file; amount of data waiting on some special files.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_ATIME">
<code class="descclassname">stat.</code><code class="descname">ST_ATIME</code><a class="headerlink" href="#stat.ST_ATIME" title="Permalink to this definition">¶</a></dt>
<dd><p>Time of last access.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_MTIME">
<code class="descclassname">stat.</code><code class="descname">ST_MTIME</code><a class="headerlink" href="#stat.ST_MTIME" title="Permalink to this definition">¶</a></dt>
<dd><p>Time of last modification.</p>
</dd></dl>

<dl class="data">
<dt id="stat.ST_CTIME">
<code class="descclassname">stat.</code><code class="descname">ST_CTIME</code><a class="headerlink" href="#stat.ST_CTIME" title="Permalink to this definition">¶</a></dt>
<dd><p>The &#8220;ctime&#8221; as reported by the operating system.  On some systems (like Unix) is
the time of the last metadata change, and, on others (like Windows), is the
creation time (see platform documentation for details).</p>
</dd></dl>

<p>The interpretation of &#8220;file size&#8221; changes according to the file type.  For plain
files this is the size of the file in bytes.  For FIFOs and sockets under most
flavors of Unix (including Linux in particular), the &#8220;size&#8221; is the number of
bytes waiting to be read at the time of the call to <a class="reference internal" href="os.html#os.stat" title="os.stat"><code class="xref py py-func docutils literal"><span class="pre">os.stat()</span></code></a>,
<a class="reference internal" href="os.html#os.fstat" title="os.fstat"><code class="xref py py-func docutils literal"><span class="pre">os.fstat()</span></code></a>, or <a class="reference internal" href="os.html#os.lstat" title="os.lstat"><code class="xref py py-func docutils literal"><span class="pre">os.lstat()</span></code></a>; this can sometimes be useful, especially
for polling one of these special files after a non-blocking open.  The meaning
of the size field for other character and block devices varies more, depending
on the implementation of the underlying system call.</p>
<p>The variables below define the flags used in the <a class="reference internal" href="#stat.ST_MODE" title="stat.ST_MODE"><code class="xref py py-data docutils literal"><span class="pre">ST_MODE</span></code></a> field.</p>
<p>Use of the functions above is more portable than use of the first set of flags:</p>
<dl class="data">
<dt id="stat.S_IFSOCK">
<code class="descclassname">stat.</code><code class="descname">S_IFSOCK</code><a class="headerlink" href="#stat.S_IFSOCK" title="Permalink to this definition">¶</a></dt>
<dd><p>Socket.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFLNK">
<code class="descclassname">stat.</code><code class="descname">S_IFLNK</code><a class="headerlink" href="#stat.S_IFLNK" title="Permalink to this definition">¶</a></dt>
<dd><p>Symbolic link.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFREG">
<code class="descclassname">stat.</code><code class="descname">S_IFREG</code><a class="headerlink" href="#stat.S_IFREG" title="Permalink to this definition">¶</a></dt>
<dd><p>Regular file.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFBLK">
<code class="descclassname">stat.</code><code class="descname">S_IFBLK</code><a class="headerlink" href="#stat.S_IFBLK" title="Permalink to this definition">¶</a></dt>
<dd><p>Block device.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFDIR">
<code class="descclassname">stat.</code><code class="descname">S_IFDIR</code><a class="headerlink" href="#stat.S_IFDIR" title="Permalink to this definition">¶</a></dt>
<dd><p>Directory.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFCHR">
<code class="descclassname">stat.</code><code class="descname">S_IFCHR</code><a class="headerlink" href="#stat.S_IFCHR" title="Permalink to this definition">¶</a></dt>
<dd><p>Character device.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFIFO">
<code class="descclassname">stat.</code><code class="descname">S_IFIFO</code><a class="headerlink" href="#stat.S_IFIFO" title="Permalink to this definition">¶</a></dt>
<dd><p>FIFO.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFDOOR">
<code class="descclassname">stat.</code><code class="descname">S_IFDOOR</code><a class="headerlink" href="#stat.S_IFDOOR" title="Permalink to this definition">¶</a></dt>
<dd><p>Door.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFPORT">
<code class="descclassname">stat.</code><code class="descname">S_IFPORT</code><a class="headerlink" href="#stat.S_IFPORT" title="Permalink to this definition">¶</a></dt>
<dd><p>Event port.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<dl class="data">
<dt id="stat.S_IFWHT">
<code class="descclassname">stat.</code><code class="descname">S_IFWHT</code><a class="headerlink" href="#stat.S_IFWHT" title="Permalink to this definition">¶</a></dt>
<dd><p>Whiteout.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last"><a class="reference internal" href="#stat.S_IFDOOR" title="stat.S_IFDOOR"><code class="xref py py-data docutils literal"><span class="pre">S_IFDOOR</span></code></a>, <a class="reference internal" href="#stat.S_IFPORT" title="stat.S_IFPORT"><code class="xref py py-data docutils literal"><span class="pre">S_IFPORT</span></code></a> or <a class="reference internal" href="#stat.S_IFWHT" title="stat.S_IFWHT"><code class="xref py py-data docutils literal"><span class="pre">S_IFWHT</span></code></a> are defined as
0 when the platform does not have support for the file types.</p>
</div>
<p>The following flags can also be used in the <em>mode</em> argument of <a class="reference internal" href="os.html#os.chmod" title="os.chmod"><code class="xref py py-func docutils literal"><span class="pre">os.chmod()</span></code></a>:</p>
<dl class="data">
<dt id="stat.S_ISUID">
<code class="descclassname">stat.</code><code class="descname">S_ISUID</code><a class="headerlink" href="#stat.S_ISUID" title="Permalink to this definition">¶</a></dt>
<dd><p>Set UID bit.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_ISGID">
<code class="descclassname">stat.</code><code class="descname">S_ISGID</code><a class="headerlink" href="#stat.S_ISGID" title="Permalink to this definition">¶</a></dt>
<dd><p>Set-group-ID bit.  This bit has several special uses.  For a directory
it indicates that BSD semantics is to be used for that directory:
files created there inherit their group ID from the directory, not
from the effective group ID of the creating process, and directories
created there will also get the <a class="reference internal" href="#stat.S_ISGID" title="stat.S_ISGID"><code class="xref py py-data docutils literal"><span class="pre">S_ISGID</span></code></a> bit set.  For a
file that does not have the group execution bit (<a class="reference internal" href="#stat.S_IXGRP" title="stat.S_IXGRP"><code class="xref py py-data docutils literal"><span class="pre">S_IXGRP</span></code></a>)
set, the set-group-ID bit indicates mandatory file/record locking
(see also <a class="reference internal" href="#stat.S_ENFMT" title="stat.S_ENFMT"><code class="xref py py-data docutils literal"><span class="pre">S_ENFMT</span></code></a>).</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_ISVTX">
<code class="descclassname">stat.</code><code class="descname">S_ISVTX</code><a class="headerlink" href="#stat.S_ISVTX" title="Permalink to this definition">¶</a></dt>
<dd><p>Sticky bit.  When this bit is set on a directory it means that a file
in that directory can be renamed or deleted only by the owner of the
file, by the owner of the directory, or by a privileged process.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IRWXU">
<code class="descclassname">stat.</code><code class="descname">S_IRWXU</code><a class="headerlink" href="#stat.S_IRWXU" title="Permalink to this definition">¶</a></dt>
<dd><p>Mask for file owner permissions.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IRUSR">
<code class="descclassname">stat.</code><code class="descname">S_IRUSR</code><a class="headerlink" href="#stat.S_IRUSR" title="Permalink to this definition">¶</a></dt>
<dd><p>Owner has read permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IWUSR">
<code class="descclassname">stat.</code><code class="descname">S_IWUSR</code><a class="headerlink" href="#stat.S_IWUSR" title="Permalink to this definition">¶</a></dt>
<dd><p>Owner has write permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IXUSR">
<code class="descclassname">stat.</code><code class="descname">S_IXUSR</code><a class="headerlink" href="#stat.S_IXUSR" title="Permalink to this definition">¶</a></dt>
<dd><p>Owner has execute permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IRWXG">
<code class="descclassname">stat.</code><code class="descname">S_IRWXG</code><a class="headerlink" href="#stat.S_IRWXG" title="Permalink to this definition">¶</a></dt>
<dd><p>Mask for group permissions.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IRGRP">
<code class="descclassname">stat.</code><code class="descname">S_IRGRP</code><a class="headerlink" href="#stat.S_IRGRP" title="Permalink to this definition">¶</a></dt>
<dd><p>Group has read permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IWGRP">
<code class="descclassname">stat.</code><code class="descname">S_IWGRP</code><a class="headerlink" href="#stat.S_IWGRP" title="Permalink to this definition">¶</a></dt>
<dd><p>Group has write permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IXGRP">
<code class="descclassname">stat.</code><code class="descname">S_IXGRP</code><a class="headerlink" href="#stat.S_IXGRP" title="Permalink to this definition">¶</a></dt>
<dd><p>Group has execute permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IRWXO">
<code class="descclassname">stat.</code><code class="descname">S_IRWXO</code><a class="headerlink" href="#stat.S_IRWXO" title="Permalink to this definition">¶</a></dt>
<dd><p>Mask for permissions for others (not in group).</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IROTH">
<code class="descclassname">stat.</code><code class="descname">S_IROTH</code><a class="headerlink" href="#stat.S_IROTH" title="Permalink to this definition">¶</a></dt>
<dd><p>Others have read permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IWOTH">
<code class="descclassname">stat.</code><code class="descname">S_IWOTH</code><a class="headerlink" href="#stat.S_IWOTH" title="Permalink to this definition">¶</a></dt>
<dd><p>Others have write permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IXOTH">
<code class="descclassname">stat.</code><code class="descname">S_IXOTH</code><a class="headerlink" href="#stat.S_IXOTH" title="Permalink to this definition">¶</a></dt>
<dd><p>Others have execute permission.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_ENFMT">
<code class="descclassname">stat.</code><code class="descname">S_ENFMT</code><a class="headerlink" href="#stat.S_ENFMT" title="Permalink to this definition">¶</a></dt>
<dd><p>System V file locking enforcement.  This flag is shared with <a class="reference internal" href="#stat.S_ISGID" title="stat.S_ISGID"><code class="xref py py-data docutils literal"><span class="pre">S_ISGID</span></code></a>:
file/record locking is enforced on files that do not have the group
execution bit (<a class="reference internal" href="#stat.S_IXGRP" title="stat.S_IXGRP"><code class="xref py py-data docutils literal"><span class="pre">S_IXGRP</span></code></a>) set.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IREAD">
<code class="descclassname">stat.</code><code class="descname">S_IREAD</code><a class="headerlink" href="#stat.S_IREAD" title="Permalink to this definition">¶</a></dt>
<dd><p>Unix V7 synonym for <a class="reference internal" href="#stat.S_IRUSR" title="stat.S_IRUSR"><code class="xref py py-data docutils literal"><span class="pre">S_IRUSR</span></code></a>.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IWRITE">
<code class="descclassname">stat.</code><code class="descname">S_IWRITE</code><a class="headerlink" href="#stat.S_IWRITE" title="Permalink to this definition">¶</a></dt>
<dd><p>Unix V7 synonym for <a class="reference internal" href="#stat.S_IWUSR" title="stat.S_IWUSR"><code class="xref py py-data docutils literal"><span class="pre">S_IWUSR</span></code></a>.</p>
</dd></dl>

<dl class="data">
<dt id="stat.S_IEXEC">
<code class="descclassname">stat.</code><code class="descname">S_IEXEC</code><a class="headerlink" href="#stat.S_IEXEC" title="Permalink to this definition">¶</a></dt>
<dd><p>Unix V7 synonym for <a class="reference internal" href="#stat.S_IXUSR" title="stat.S_IXUSR"><code class="xref py py-data docutils literal"><span class="pre">S_IXUSR</span></code></a>.</p>
</dd></dl>

<p>The following flags can be used in the <em>flags</em> argument of <a class="reference internal" href="os.html#os.chflags" title="os.chflags"><code class="xref py py-func docutils literal"><span class="pre">os.chflags()</span></code></a>:</p>
<dl class="data">
<dt id="stat.UF_NODUMP">
<code class="descclassname">stat.</code><code class="descname">UF_NODUMP</code><a class="headerlink" href="#stat.UF_NODUMP" title="Permalink to this definition">¶</a></dt>
<dd><p>Do not dump the file.</p>
</dd></dl>

<dl class="data">
<dt id="stat.UF_IMMUTABLE">
<code class="descclassname">stat.</code><code class="descname">UF_IMMUTABLE</code><a class="headerlink" href="#stat.UF_IMMUTABLE" title="Permalink to this definition">¶</a></dt>
<dd><p>The file may not be changed.</p>
</dd></dl>

<dl class="data">
<dt id="stat.UF_APPEND">
<code class="descclassname">stat.</code><code class="descname">UF_APPEND</code><a class="headerlink" href="#stat.UF_APPEND" title="Permalink to this definition">¶</a></dt>
<dd><p>The file may only be appended to.</p>
</dd></dl>

<dl class="data">
<dt id="stat.UF_OPAQUE">
<code class="descclassname">stat.</code><code class="descname">UF_OPAQUE</code><a class="headerlink" href="#stat.UF_OPAQUE" title="Permalink to this definition">¶</a></dt>
<dd><p>The directory is opaque when viewed through a union stack.</p>
</dd></dl>

<dl class="data">
<dt id="stat.UF_NOUNLINK">
<code class="descclassname">stat.</code><code class="descname">UF_NOUNLINK</code><a class="headerlink" href="#stat.UF_NOUNLINK" title="Permalink to this definition">¶</a></dt>
<dd><p>The file may not be renamed or deleted.</p>
</dd></dl>

<dl class="data">
<dt id="stat.UF_COMPRESSED">
<code class="descclassname">stat.</code><code class="descname">UF_COMPRESSED</code><a class="headerlink" href="#stat.UF_COMPRESSED" title="Permalink to this definition">¶</a></dt>
<dd><p>The file is stored compressed (Mac OS X 10.6+).</p>
</dd></dl>

<dl class="data">
<dt id="stat.UF_HIDDEN">
<code class="descclassname">stat.</code><code class="descname">UF_HIDDEN</code><a class="headerlink" href="#stat.UF_HIDDEN" title="Permalink to this definition">¶</a></dt>
<dd><p>The file should not be displayed in a GUI (Mac OS X 10.5+).</p>
</dd></dl>

<dl class="data">
<dt id="stat.SF_ARCHIVED">
<code class="descclassname">stat.</code><code class="descname">SF_ARCHIVED</code><a class="headerlink" href="#stat.SF_ARCHIVED" title="Permalink to this definition">¶</a></dt>
<dd><p>The file may be archived.</p>
</dd></dl>

<dl class="data">
<dt id="stat.SF_IMMUTABLE">
<code class="descclassname">stat.</code><code class="descname">SF_IMMUTABLE</code><a class="headerlink" href="#stat.SF_IMMUTABLE" title="Permalink to this definition">¶</a></dt>
<dd><p>The file may not be changed.</p>
</dd></dl>

<dl class="data">
<dt id="stat.SF_APPEND">
<code class="descclassname">stat.</code><code class="descname">SF_APPEND</code><a class="headerlink" href="#stat.SF_APPEND" title="Permalink to this definition">¶</a></dt>
<dd><p>The file may only be appended to.</p>
</dd></dl>

<dl class="data">
<dt id="stat.SF_NOUNLINK">
<code class="descclassname">stat.</code><code class="descname">SF_NOUNLINK</code><a class="headerlink" href="#stat.SF_NOUNLINK" title="Permalink to this definition">¶</a></dt>
<dd><p>The file may not be renamed or deleted.</p>
</dd></dl>

<dl class="data">
<dt id="stat.SF_SNAPSHOT">
<code class="descclassname">stat.</code><code class="descname">SF_SNAPSHOT</code><a class="headerlink" href="#stat.SF_SNAPSHOT" title="Permalink to this definition">¶</a></dt>
<dd><p>The file is a snapshot file.</p>
</dd></dl>

<p>See the *BSD or Mac OS systems man page <em class="manpage">chflags(2)</em> for more information.</p>
<p>On Windows, the following file attribute constants are available for use when
testing bits in the <code class="docutils literal"><span class="pre">st_file_attributes</span></code> member returned by <a class="reference internal" href="os.html#os.stat" title="os.stat"><code class="xref py py-func docutils literal"><span class="pre">os.stat()</span></code></a>.
See the <a class="reference external" href="http://msdn.microsoft.com/en-us/library/windows/desktop/gg258117.aspx">Windows API documentation</a>
for more detail on the meaning of these constants.</p>
<dl class="data">
<dt id="stat.FILE_ATTRIBUTE_ARCHIVE">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_ARCHIVE</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_ARCHIVE" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_COMPRESSED">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_COMPRESSED</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_COMPRESSED" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_DEVICE">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_DEVICE</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_DEVICE" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_DIRECTORY">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_DIRECTORY</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_DIRECTORY" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_ENCRYPTED">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_ENCRYPTED</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_ENCRYPTED" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_HIDDEN">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_HIDDEN</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_HIDDEN" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_INTEGRITY_STREAM">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_INTEGRITY_STREAM</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_INTEGRITY_STREAM" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_NORMAL">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_NORMAL</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_NORMAL" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_NOT_CONTENT_INDEXED">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_NOT_CONTENT_INDEXED</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_NOT_CONTENT_INDEXED" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_NO_SCRUB_DATA">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_NO_SCRUB_DATA</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_NO_SCRUB_DATA" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_OFFLINE">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_OFFLINE</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_OFFLINE" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_READONLY">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_READONLY</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_READONLY" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_REPARSE_POINT">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_REPARSE_POINT</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_REPARSE_POINT" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_SPARSE_FILE">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_SPARSE_FILE</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_SPARSE_FILE" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_SYSTEM">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_SYSTEM</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_SYSTEM" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_TEMPORARY">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_TEMPORARY</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_TEMPORARY" title="Permalink to this definition">¶</a></dt>
<dt id="stat.FILE_ATTRIBUTE_VIRTUAL">
<code class="descclassname">stat.</code><code class="descname">FILE_ATTRIBUTE_VIRTUAL</code><a class="headerlink" href="#stat.FILE_ATTRIBUTE_VIRTUAL" title="Permalink to this definition">¶</a></dt>
<dd><div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="fileinput.html"
                        title="previous chapter">11.3. <code class="docutils literal"><span class="pre">fileinput</span></code> &#8212; Iterate over lines from multiple input streams</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="filecmp.html"
                        title="next chapter">11.5. <code class="docutils literal"><span class="pre">filecmp</span></code> &#8212; File and Directory Comparisons</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/stat.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="filecmp.html" title="11.5. filecmp — File and Directory Comparisons"
             >next</a> |</li>
        <li class="right" >
          <a href="fileinput.html" title="11.3. fileinput — Iterate over lines from multiple input streams"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="filesys.html" >11. File and Directory Access</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>